#include <mem.h>
#include <time.h>
#include "event.h"
#include "key.h"
#include "magmou.h"

static int max_hands=-1;

Event evs[MAX_EVENT];
int evs_top=0;

Handler hds[MAX_HANDLER];


	//   ࠡ稪

int pascal addHand
	( byte act, func_event hand )
{
register int i;
static int first=0;
if ( first==0 )
{
	clearHands();
	first=1;
}
for ( i=0; i<MAX_HANDLER; i++ )
   if ( hds[i].active==HAND_NO )
   {
	hds[i].active=act;
	hds[i].hand=hand;
	if ( i>max_hands ) max_hands=1;
	return i;
   }
return -1;
}


	//  ࠡ稪

void pascal delHand
	( int n )
{
if ( n<0 || n>=MAX_HANDLER ) return;
hds[n].active=HAND_NO;
hds[n].hand=0;
if ( n==max_hands ) max_hands--;
}


	//   ࠡ稪

void pascal clearHands
	( void )
{
register int i;
for ( i=0; i<MAX_HANDLER; i++ )
	delHand(i);
}


	//  ⨯ ࠡ稪

void pascal setActiveHand
	( int n, int act )
{
if ( n<0 || n>=MAX_HANDLER ) return;
hds[n].active=act;
}


	//   ᮮ饭

void pascal setEvents
	( void )
{
register int i;
static Event ev;
for ( i=0; i<MAX_HANDLER; i++ )
  if ( hds[i].active==HAND_EVENT )
	hds[i].hand(&ev,i);
}


	//  ᮮ饭

void pascal getEvent
	( Event * e, byte preview )
{
if ( evs_top<0 ) evs_top=0;
if ( evs_top>=MAX_EVENT ) evs_top=MAX_EVENT-1;
if ( evs_top==0 ) { e->ev=EV_NULL; return; }
memcpy(e,&evs[0],sizeof(Event));
if ( preview==PRE_EVENT ) return;
evs_top--; if ( evs_top<0 ) evs_top=0;
memmove(&evs[0],&evs[1],sizeof(Event)*evs_top);
memset(&evs[evs_top],0,sizeof(Event));
}


	//   ᮮ饭

void pascal delEvents
	( void )
{
memset(&evs[0],0,sizeof(Event)*MAX_EVENT);
evs_top=0;
clear_buffer();
magPressMouse();
}


	// ᫠ ᮮ饭

void pascal sendEvent
	( Event * e )
{
if ( evs_top<0 ) evs_top=0;
if ( evs_top>=MAX_EVENT ) evs_top=MAX_EVENT-1;
memcpy(&evs[evs_top],e,sizeof(Event));
evs_top++;
}

	// ࠡ⪠ ᮮ饭

int pascal handEvent
	( void )
{
register word i;
static Event e;
getEvent(&e,PRE_NO);
i=e.p1;
switch ( e.ev )
{
case EV_NULL: return 0; //  ଠ쭮
case EV_QUIT_SYSTEM: return -1; // 室
case EV_HAND: if ( i<MAX_HANDLER && hds[i].active!=HAND_NO )
		hds[i].hand(&e,i);
		return 1; // 0
}
// ᭠砫  䮪
for ( i=0; i<MAX_HANDLER; i++ )
   if ( hds[i].active==HAND_FOCUS )
	if ( hds[i].hand(&e,i)==YES_HAND ) return 1; // 0
// ⥬  ⨢
for ( i=0; i<MAX_HANDLER; i++ )
   if ( hds[i].active==HAND_ACTIVE )
	if ( hds[i].hand(&e,i)==YES_HAND ) return 1; // 0
return 0;
}


	// ࠡ稪 

int	event_key
	( Event * e, word n )
{
int ev;
static Event ek;
ev=ready_key();
if ( ev==evNOT ) return NO_HAND;
if ( ev & evKey )
{
	ek.ev=EV_KEY;
	ek.p1=(int)read_key();
	ek.p2=(int)read_flags();
	sendEvent(&ek);
}
if ( ev & evFlags )
{
	ek.ev=EV_FLAGS;
	ek.p1=(int)read_flags();
	sendEvent(&ek);
}
return YES_HAND;
}


	// ࠡ稪 

int	event_mouse
	( Event * e, word n )
{
static int old_b=-1;
static Event em;
word mou_m, mou_p, x, y, mou_b;
mou_m=magMoveMouse();
mou_b=magButMouse(&x,&y);
mou_p=magPressMouse();
if ( mou_b!=old_b || mou_b!=0 )
{
	em.ev=EV_MOUSE_BUT;
	em.p1=x;em.p2=y;em.p3=mou_b;
	old_b=mou_b;
	sendEvent(&em);
}
if ( mou_m )
{
	em.ev=EV_MOUSE_MOVE;
	em.p1=x;em.p2=y;em.p3=mou_b;
	sendEvent(&em);
}
if ( mou_p )
{
	em.ev=EV_MOUSE_PRESS;
	em.p1=x;em.p2=y;em.p3=mou_p;
	sendEvent(&em);
}
return YES_HAND;
}


	//  ணࠬ
static int first_do=0;

void pascal runProg
	( void )
{
if ( first_do==0 )
{
	addHand(HAND_EVENT,event_mouse);
	addHand(HAND_EVENT,event_key);
	first_do=1;
}
while ( 1 )
{
	setEvents();
	if ( handEvent()==-1 ) return;
}
}

	//   室 ᮡ

void pascal waitEvent
	( long time_wait, Event * e )
{
time_t s;

s=time(0);
if ( first_do==0 )
{
	addHand(HAND_EVENT,event_mouse);
	addHand(HAND_EVENT,event_key);
	first_do=1;
}
while ( 1 )
{
	setEvents();
	getEvent(e,PRE_NO);
	if ( e->ev==EV_KEY || e->ev==EV_MOUSE_PRESS ) break;
	if ( (time(0)-s)>=time_wait )
		break;
}
}
