#ifndef __EVENT_H
#define __EVENT_H

#ifndef __MAGTYPE_H
#include "magtype.h"
#endif

typedef struct
{
	int ev;
	int p1;
	int p2;
	int p3;
	int p4;
} Event;

#define MAX_EVENT 50

extern Event evs[MAX_EVENT];
extern int evs_top;

typedef enum
{
	EV_NULL=0,
	EV_QUIT_SYSTEM,
        EV_HAND,
	EV_KEY,
	EV_FLAGS,
	EV_MOUSE_MOVE,
	EV_MOUSE_BUT,
	EV_MOUSE_PRESS,
} TypeEvent;

typedef int (*func_event)(Event *, word );

typedef struct
{
	byte active;
	func_event hand;
} Handler;

#define MAX_HANDLER 256

typedef enum
{
	HAND_NO=0,
	HAND_PASSIVE,
	HAND_ACTIVE,
	HAND_FOCUS,
	HAND_EVENT,
} TypeHandler;

typedef enum
{
	YES_HAND=0,
	NO_HAND=1,
} TypeReturn;

typedef enum
{
	PRE_EVENT=0,
	PRE_NO=1,
} TypePreview;

extern Handler hds[MAX_HANDLER];


#ifdef __cplusplus
extern "C" {
#endif
	//   ࠡ稪
int pascal addHand
	( byte act, func_event hand );
	//  ࠡ稪
void pascal delHand
	( int n );
	//   ࠡ稪
void pascal clearHands
	( void );
	//  ⨯ ࠡ稪
void pascal setActiveHand
	( int n, int act );
	//   ᮮ饭
void pascal setEvents
	( void );
	//  ᮮ饭
void pascal getEvent
	( Event * e, byte preview );
	//   ᮮ饭
void pascal delEvents
	( void );
	// ᫠ ᮮ饭
void pascal sendEvent
	( Event * e );
	// ࠡ⪠ ᮮ饭
int pascal handEvent
	( void );
	//  ணࠬ
void pascal runProg
	( void );
	//   室 ᮡ
void pascal waitEvent
	( long time_wait, Event * e );


#ifdef __cplusplus
}
#endif

#endif
