#include <stdio.h>
#include <alloc.h>
#include <string.h>

typedef unsigned int word;
typedef unsigned char byte;

typedef struct 
{
	word	ver;
	long	size;
	char	copyright[60];
	word	type;
	word	points;
	word	vert_res;
	word	horiz_res;
	word	ascent;
	word	int_lead;
	word	ext_lead;
	byte	italic;
	byte	underline;
	byte	strike_out;
	word	weight;
	byte	char_set;
	word	pix_wid;
	word	pix_hei;
	byte	pitch;
	word	avg;
	word	max;
	byte	first;
	byte	last;
	byte	def;
	byte	break_char;
	word	bytes;
	long	device;
	long	face;
	long	pointer;
	long	offset;
	byte	res1;
} FontWin;

typedef struct {
	long	flags;
	word	a;
	word	b;
	word	c;
	word	color;
	long	res2;
} AddFont;

typedef struct {
	word	width;
	word	offset;
} CharTable2;

typedef struct {
	word	width;
	long	offset;
} CharTable3;

FontWin fw;
AddFont af;
char face[21];
CharTable2 ct2[257];
CharTable3 ct3[257];

char far * bits=0;

#define ID_FONT 'MF'

typedef union {
	char far * ptr;
	long	off;
} Offset;

typedef struct {
	word	width;		// ਭ ᨬ
	Offset	o;		// ᬥ饭 ⭮⥫쭮 砫 
} WidthTable;

typedef struct {
	word	id;		// 䨪
	byte	ver;		//  - 0
	word	width;		// ਭ !=0 - ਩
	word	height;		// 
	char	face[21];	//  
	long	len;		//  
	WidthTable wt[256];	// ⠡ ਭ
	Offset	bits;		// 㪠⥫  
	long	res1;
	long	res2;
} MagFont;

MagFont mf;

#define LEN_MAX_BIT	14
#define	LEN_BUF_PACK	2047
#define	LEN_PACK_MAX	(1<<LEN_MAX_BIT)-1
#define REPEAT		1
#define NO_REPEAT	0
#define LIT_NUMBER	1<<(LEN_MAX_BIT-8)

char buf_ch[LEN_BUF_PACK+1];

int	write_zip
	( FILE * f, char * buf, word count, byte state )
{
word p,size;
int rc=-1;
if ( count>=LIT_NUMBER )
{
	size=state & 3;
	size<<=LEN_MAX_BIT; size|=(count & 0x3fff);
	p=(size>>8)&0xff; p|=(size<<8)&0xff00;
	size=2;
}
else
{
	p=(state+2) & 3;
	p<<=LEN_MAX_BIT-8; p|=(count & 0x3f);
	size=1;
}
switch ( state )
{
case REPEAT: {
	rc=fwrite(&p,1,size,f);//᫮  ﭨ
	rc=fwrite(buf,1,1,f);//ᨬ
	break;
	}
case NO_REPEAT: {
	rc=fwrite(&p,1,size,f);//᫮  ﭨ
	rc=fwrite(buf,1,count,f);//
	break;
	}
}
return rc;
}

int	pascal zip_buf
	( FILE *f, long len, char far * buf )
{
char _huge * b;
word count;
byte state;
long ptr;
char ch, prefix;
int rc;
//char * buf_wr=0;
//long offset_len=0, len_zip=0;

b=buf;
state=REPEAT;
count=1;
ch=*b;

//setvbuf(f,buf_wr,_IOFBF,4096);
//fgetpos(f,&offset_len);
//fwrite(&len_zip,1,4,f);

for ( ptr=1L; ptr<len; ptr++ )
{
b++;
prefix=*b;
if ( ch==prefix )
{
    if ( state==REPEAT )
    {
	count++;
	if ( count>=LEN_PACK_MAX )
	{
	   rc=write_zip(f,&ch,count,state);
	   if ( rc==-1 ) return rc;
	   count=1;
	}
    }
    else
    {
	if ( count!=1 )
	{
	rc=write_zip(f,buf_ch,count-1,state);
	if ( rc==-1 ) return rc;
	}
	state=REPEAT;
	count=2;
    }
}
else
{
    if ( state==REPEAT )
    {
	rc=write_zip(f,&ch,count,state);
	if ( rc==-1 ) return rc;
	count=1; state=NO_REPEAT; buf_ch[0]=prefix;
    }
    else
    {
	buf_ch[count++]=prefix;
	if ( count>=LEN_BUF_PACK )
	{
		rc=write_zip(f,buf_ch,count,state);
		if ( rc==-1 ) return rc;
		count=0;
	}
    }
}//else
ch=prefix;
}//for
if ( state==REPEAT )
{
	rc=write_zip(f,&ch,count,state);
	if ( rc==-1 ) return rc;
}
else
{
	rc=write_zip(f,buf_ch,count,state);
	if ( rc==-1 ) return rc;
}
fflush(f);
/*fgetpos(f,&len_zip);
len_zip=len_zip-offset_len-4;
fsetpos(f,&offset_len);
fwrite(&len_zip,1,4,f);
offset_len+=len_zip+4;
fsetpos(f,&offset_len);*/
return 0;
}

void	main
	( int argc, char * argv[] )
{
FILE * f;
FILE * fm;
int count_char, i, j;
long off, len, il;

printf(" FNT - 䠩 ( Windows 3 ). ᨬ .. 1995 v1\n");
if ( argc<3 ) { printf("  䠩 !!!\n"); return; }
f=fopen(argv[1],"rb");
if ( f==0 ) { printf("   䠩 - %s\n",argv[1]); return; }

fm=fopen(argv[2],"wb");
if ( fm==0 ) { printf("   䠩 - %s\n",argv[2]); return; }

// ⥭ 
fread(&fw,sizeof(FontWin),1,f);
if ( ferror(f) )
{
	printf("訡 ⥭\n");
	goto Fin;
}
if ( fw.ver!=0x200 && fw.ver!=0x300 )
{
	printf(" ࠢ쭠  - 0x%X\n",fw.ver);
	goto Fin;
}
if ( fw.ver==0x300 )
	fread(&af,sizeof(AddFont),1,f);

printf(" - 0x%X\n",fw.ver);

count_char=fw.last-fw.first+2;
if ( fw.ver==0x200 )
	fread(&ct2,sizeof(CharTable2),count_char,f);
else
	fread(&ct3,sizeof(CharTable3),count_char,f);


fw.copyright[59]=0;
printf("Copyright - %s\n",fw.copyright);

if ( (fw.type&1)==0 ) printf("஢ \n");
else printf(" \n");

printf("   㭪 - %d\n",fw.points);

printf("襭  ⨪/ਧ⠫ - %d/%d\n",
	fw.vert_res,fw.horiz_res);

printf("  - %d\n", fw.ascent);

printf("業 - %d\n", fw.int_lead);
printf(" ப - %d\n", fw.ext_lead);
printf(" - %d\n", fw.weight);
printf(" ᨬ - %d\n", fw.char_set);

printf(" - %d\n", fw.pix_wid);
printf(" - %d\n", fw.pix_hei);
printf("  - %d\n", fw.bytes );
printf("Avg -%d; Max - %d\n", fw.avg, fw.max );
printf(" - %d, ᫥ - %d, ᥣ - %d\n",
	fw.first, fw.last, count_char );
printf(" 㬮砭 - %d\n", fw.def );
printf("砫  - %X\n", fw.offset );

fseek(f,fw.face,SEEK_SET);
fread(face,20,1,f);
face[20]=0;
printf(" - %s\n",face);

printf(" ਭ\n");
if ( fw.ver==0x200 )
{
for ( i=0; i<count_char; i++ )
{
	if ( i%5==0 && i!=0 ) printf("\n");
	printf("%c:W-%03d/%04X   ",fw.first+i,ct2[i].width,ct2[i].offset);
}
}
else
{
for ( i=0; i<count_char; i++ )
{
	if ( i%8==0 && i!=0 ) printf("\n");
	printf("%c:W-%03d ",fw.first+i,ct3[i].width);
}
}
printf("\n");

if ( fw.ver==0x200 )
	{ off=ct2[0].offset;
	  i=ct2[count_char-1].width;
	  i=i/8+(i%8?1:0);
	  len=ct2[count_char-1].offset+i*fw.pix_hei;
	}
else
	{ off=ct3[0].offset;
	  i=ct3[count_char-1].width;
	  i=i/8+(i%8?1:0);
	  len=ct3[count_char-1].offset+i*fw.pix_hei;
	}
len-=off;

printf("砫  - %lX;  - %lX\n", off, len );

if ( len>=0xffff ) { printf("  \n"); goto Fin; }

bits=(char far * )farmalloc(len);
if ( bits==0 ) { printf("  !\n"); goto Fin; }

fseek(f,off,SEEK_SET);
fread(bits,len,1,f);

//  䮭
mf.id=ID_FONT;
mf.ver=0;
mf.width=fw.pix_wid;
mf.height=fw.pix_hei;
strcpy(mf.face,face);
mf.len=len;

for ( i=0; i<256; i++ )
{
	mf.wt[i].width=0;
	mf.wt[i].o.off=0L;
}

if ( fw.ver==0x200 )
{
for ( i=fw.first; i<fw.last+1; i++ )
{
	j=i;
	if ( i>=0x80 && i<0xb0 ) j+=0x30;
	if ( i>=0xb0 && i<0xc0 ) j+=0x40;
	if ( i>=0xc0 && i<0xf0 ) j-=0x40;
	if ( i>=0xf0 && i<0x100 ) j-=0x10;
	mf.wt[j].width=ct2[i-fw.first].width;
	mf.wt[j].o.off=ct2[i-fw.first].offset-off; // ᬥ饭 ⭮⥫쭮 砫 
}
}
else
{
for ( i=fw.first; i<fw.last+1; i++ )
{
	j=i;
	if ( i>=0x80 && i<0xb0 ) j+=0x30;
	if ( i>=0xb0 && i<0xc0 ) j+=0x40;
	if ( i>=0xc0 && i<0xf0 ) j-=0x40;
	if ( i>=0xf0 && i<0x100 ) j-=0x10;
	mf.wt[j].width=ct3[i-fw.first].width;
	mf.wt[j].o.off=ct3[i-fw.first].offset-off; // ᬥ饭 ⭮⥫쭮 砫 
}
}
mf.bits.off=sizeof(MagFont);

fseek(fm,0L,SEEK_SET);
fwrite(&mf,sizeof(MagFont),1,fm);
//fwrite(bits,len,1,fm);
zip_buf(fm,len,bits);

Fin:
if ( bits!=0 ) farfree(bits);
fclose(fm);
fclose(f);
}

