
#ifndef __GIF_H
#define __GIF_H

#ifndef __MAGTYPE_H
#include "magtype.h"
#endif

// ⥫ ࠭
typedef struct
{
	word width;
	word height;
	byte max_color:3; // 梥⮢ + 1
	byte res1:1;
	byte resol:3;// 梥⮢ + 1
	byte pal:1;// 쭠  梥 - 1
	byte fonColor;
	byte nulls;
} gifHeader;

// ⥫ ࠦ
typedef struct
{
	byte comma;
	word left;
	word top;
	word width;
	word height;
	byte bit:3; //   ᥫ
	byte res1:3;
	byte inter:1;// 0 - ଠ 冷
	byte pal:1; // 1 - 쭠 
}  gifImageHeader;


#define IMAGE_DESC	0x2c
#define GIF_END		0x3B
#define GIF_ADD		0x21
#define GIF_ERROR	0xFF

#define TABLE_SIZE	5021

#define LZ_MAX_CODE	4095
#define FLUSH_OUT	4096
#define FIRST_CODE	4097
#define BITS		12
#define NOT_CODE	4098
#define MAX_BIT_PER_CODE 12
#define GIF_TITLE	"GIF87a"
#define NO_GIF		-100
#define NO_GIF_256	-101
#define NO_GIF_IMAGE	-101

int	pascal magReadHeaderGif
	( char * nf, gifHeader * gh, gifImageHeader * gih, char * buf_pal );

int	pascal magReadGif
	( int hGif, gifImageHeader * gih, char far * image );

int	pascal magWriteHeaderGif
	( char * fileName, gifHeader * gh, char * buf_pal );

int	pascal magWriteGif
	( int hGif, gifImageHeader * gih, char far * image );

int	pascal magGifMem
	( void );

void	pascal magGifDelMem
	( void );

#endif
