#include <dos.h>
#include <alloc.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include "gif.h"
#include "maglib.h"

int bitPerCode, bitPerPixel, EOFCode, ClearCode, nextByte;
int maxCodeMult2;
byte buffer[256];
int  hGif, rc=0;
unsigned long codeBuffer, runCode;
int curBufferShift;
extern char * stack;
extern word * prefix;
extern word * sufix;
int oldCode, stackCount;

	// ⥭ 
byte	pascal getByte
	( void )
{
byte code;
if ( buffer[0]==0 )
{
	rc=_read_buf(hGif,buffer,1);
	rc=_read_buf(hGif,(buffer+1),buffer[0]);
	code=buffer[1];
	nextByte=2;
	buffer[0]--;
}
else
{
	code=buffer[nextByte++];
	buffer[0]--;
}
return code;
}


	// 

int	pascal getCode
	( void )
{
unsigned char byt;
unsigned long longByte;
int code;
static unsigned int CodeMasks[13] = {
	0x0000, 0x0001, 0x0003, 0x0007,
	0x000f, 0x001f, 0x003f, 0x007f,
	0x00ff, 0x01ff, 0x03ff, 0x07ff,
	0x0fff
    };
while ( curBufferShift<bitPerCode )
{
	byt=getByte();
	longByte=(unsigned long)byt;
	longByte<<=curBufferShift;
	codeBuffer|=longByte;
	curBufferShift+=8;
}
code = (int ) (codeBuffer & CodeMasks[bitPerCode]) ;
codeBuffer>>=bitPerCode;
curBufferShift-=bitPerCode;
codeBuffer&=CodeMasks[curBufferShift];
return code;
}

	// ஢  ⥪

void	pascal decode
	( int count, int code )
{
stackCount=LZ_MAX_CODE-count;
while ( code>ClearCode )
{
	stack[stackCount--]=sufix[code];
	code=prefix[code];
}
stack[stackCount--]=(char)code;
//  ᫮
sufix[runCode]=stack[stackCount+1];
prefix[runCode]=oldCode;
runCode++;
if (runCode >= maxCodeMult2 && runCode<=LZ_MAX_CODE )
	maxCodeMult2=1<<++bitPerCode;
/*
switch ( runCode )
{
case 2: case 4: case 8: case 0x10: case 0x20: case 0x40: case 0x80:
case 0x100: case 0x200: case 0x400: case 0x800:
	bitPerCode++;
}
*/
}


	//  

int	pascal magGifDeLine
	( unsigned char * line, int lineLen )
{
int i=0, code, count;
rc=1;
if ( stackCount<=LZ_MAX_CODE )
{
    count=LZ_MAX_CODE-stackCount;
    if ( count>lineLen ) count=lineLen;
    copyByte(stack+stackCount+1,line,count);
    i+=count;
    stackCount+=count;
}
while (i<lineLen)
{
   code=getCode();
   if ( rc==-1 ) return NO_READ;

   if ( code==EOFCode ) return 0;

   if ( code==ClearCode )
   {
	runCode=EOFCode+1;
	bitPerCode=bitPerPixel+1;
	maxCodeMult2=1<<bitPerCode;
	oldCode=NOT_CODE;
	continue;
   }

   if ( oldCode==NOT_CODE )
   {
	line[i++]=code;
	oldCode=code;
	continue;
   }

   if ( code<runCode )
   {
	decode(0,code);
	line[i++]=stack[++stackCount];
	oldCode=code;
   }
   else
   {
	decode(1,oldCode);
	stack[LZ_MAX_CODE]=stack[stackCount+1];
	line[i++]=stack[++stackCount];
	oldCode=code;
   }

   if ( stackCount<=LZ_MAX_CODE )
   {
	count=LZ_MAX_CODE-stackCount;
	if ( count>(lineLen-i) ) count=lineLen-i;
	copyByte(stack+stackCount+1,line+i,count);
	i+=count;
	stackCount+=count;
   }
}
return 1;
}

int 	pascal magGifInitDe
	( void )
{
int k;
char CodeSize;
_read(hGif,&CodeSize, 1 );
bitPerPixel =CodeSize;
buffer[0]=0;
nextByte =0;
ClearCode=1<<bitPerPixel;
EOFCode=ClearCode+1;
runCode=EOFCode+1;
bitPerCode=bitPerPixel+1;
maxCodeMult2=1<<bitPerCode;
stackCount=LZ_MAX_CODE;
oldCode=NOT_CODE;
curBufferShift=0;
codeBuffer=0;
for ( k=0; k<LZ_MAX_CODE; k++ )
	prefix[k]=NOT_CODE;
for ( k=0; k<EOFCode; k++ )
	sufix[k]=k;
return 0;
}

	//
	
int	pascal magReadHeaderGif
	( char * nf, gifHeader * gh, gifImageHeader * gih, char * buf_pal )
{
char label[8];
int i, rc;
hGif=_open ( nf, O_RDONLY | O_BINARY );
if ( hGif==-1 ) return NO_FILE;
rc=_read(hGif,&label,6);
if ( rc==-1 ) return NO_READ;
label[6]=0;
if ( strcmp(label,GIF_TITLE)!=0 ) return NO_GIF;
rc=_read(hGif,gh,sizeof(gifHeader));
if ( rc==-1 ) return NO_READ;
if ( (gh->max_color+1)<8 ) return NO_GIF_256;
if ( gh->pal )
{
	rc=_read(hGif,buf_pal,LEN_PAL_256);
	if ( rc==-1 ) return NO_READ;
	for ( i=0; i<LEN_PAL_256; i++ )
		buf_pal[i]=(buf_pal[i]>>2)&0x3f;
}
COMMA:
rc=_read(hGif,label,1);
if ( rc==-1 ) return NO_READ;
i=label[0];
switch ( i )
{
case IMAGE_DESC: lseek(hGif,-1L,SEEK_CUR); break;
case GIF_ADD:
{
	rc=_read(hGif,label,2);
	if ( rc==-1 ) return NO_READ;
	i=label[1];
	while ( i!=0 )
	{
	   rc=lseek(hGif,i*1L,SEEK_CUR);
	   rc=_read(hGif,label,1);
	   if ( rc==-1 ) return NO_READ;
	   i=label[0];
	}
	goto COMMA;
}
case GIF_ERROR: return NO_GIF_IMAGE;
case GIF_END: return NO_GIF_IMAGE;
}
rc=_read(hGif,gih,sizeof(gifImageHeader));
if ( rc==-1 ) return NO_READ;
if ( gih->comma != IMAGE_DESC ) return NO_GIF_IMAGE;
if ( gih->pal )
{
	rc=_read(hGif,buf_pal,LEN_PAL_256);
	if ( rc==-1 ) return NO_READ;
	for ( i=0; i<LEN_PAL_256; i++ )
		buf_pal[i]=(buf_pal[i]>>2)&0x3f;
}
return hGif;
}

	//

int	pascal magReadGif
	( int h, gifImageHeader * gih, char far * image )
{
char far * b;
int rc;
word y;
b=image;
hGif=h;
if ( prefix==0 ) magGifMem();
magGifInitDe();
i_buf=-1;
for( y=0; y<gih->height; y++ )
{
	rc=magGifDeLine ( b, gih->width);
	if ( rc<0 ) return rc;
	b=addAddr(b, gih->width);
	if ( rc==0 ) break;
}
return OK;
}
