#include <stdio.h>
#include <alloc.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <string.h>
#include "maglib.h"
#include "gif.h"

extern int bitPerCode, bitPerPixel, EOFCode, ClearCode, nextByte;
extern int maxCodeMult2;
extern byte buffer[256];
extern int rc;
extern unsigned long codeBuffer, runCode;
extern int curBufferShift;
extern char * stack;
extern word * prefix;
extern word * sufix;

static int runningBits, curCode, newCode, hGifW, pixel;

// 뢥   . ᫨  ९  ९   䠩.

int	pascal outByte
	( int code)
{
if (code==FLUSH_OUT)
   {
	if (buffer[0] != 0)
	    rc=_write(hGifW,buffer,buffer[0]+1);
	    if ( rc==-1 ) return NO_WRITE;
	    buffer[0]=0; buffer[1]=0x3b;
	    rc=_write(hGifW,buffer,2);
	    if ( rc==-1 ) return NO_WRITE;
    }
else
    {
	if (buffer[0]==254)
	   {
		//  . 뢥 .
		rc=_write(hGifW,buffer,buffer[0]+1);
		if ( rc==-1 ) return NO_WRITE;
		buffer[0]=0;
	    }
	buffer[++buffer[0]]=(byte)code;
     }
return OK;
}

	//  㯫⭨⥫

int	pascal magGifCoCode
	( int code )
{
if (code==FLUSH_OUT)
{
   while (curBufferShift>0)
     {
	rc=outByte((int) (codeBuffer & 0xFF));
        if ( rc==-1 ) return NO_WRITE;
	codeBuffer>>=8;
	curBufferShift-=8;
     }
   curBufferShift=0;
   rc=outByte(FLUSH_OUT);
   if ( rc==-1 ) return NO_WRITE;
}
else
{
    codeBuffer |= ((long) code) << curBufferShift;
    curBufferShift += runningBits;
    while (curBufferShift >= 8)
      {
	// 뢮  .
	rc=outByte((int)(codeBuffer & 0xFF));
	if ( rc==-1 ) return NO_WRITE;
	codeBuffer >>= 8;
	curBufferShift -= 8;
       }
}
if (runCode >= maxCodeMult2 && runCode<=LZ_MAX_CODE )
	maxCodeMult2=1<<++runningBits;
return OK;
}

	//    㭪樨 ஢

int	pascal findKey
	( int pref, int ch )
{
int index, offset;
index=((ch<<4)^pref) & 0xfff;
if ( index==0 ) offset=1;
else offset=TABLE_SIZE-index;
for ( ; ; )
{
    if ( sufix[index]==0xffff )
	return index;
    if ( (prefix[index]==pref) && (stack[index]==(char)ch) )
	return index;
    index-=offset;
    if ( index<0 )
	index+=TABLE_SIZE;
}
}


	// 塞 ᫥⥫쭮 ᨬ  .

int	pascal magGifCoLine
	( char * line, word lineLen)
{
int i=0, index;

if (curCode==FIRST_CODE)
	curCode=((int)line[i++])&0xff;

while (i<lineLen)
{

   pixel=((int)line[i++])&0xff;
   index=findKey(curCode,pixel);

   if ( sufix[index]!=0xffff )
   {
	// ᮮ⢥⢨ 
	curCode=sufix[index];
	continue;
   }

   rc=magGifCoCode(curCode);
   if ( rc==-1 ) return NO_WRITE;
   if (runCode >= LZ_MAX_CODE)
      {
	rc=magGifCoCode(ClearCode);
	if ( rc==-1 ) return NO_WRITE;
	runCode=EOFCode+1;
	runningBits=bitPerPixel+1;
	maxCodeMult2 = 1<<runningBits;
	memset(prefix,0xff,TABLE_SIZE*sizeof(word));
	memset(sufix,0xff,TABLE_SIZE*sizeof(word));
	memset(stack,0xff,TABLE_SIZE*sizeof(byte));
       }
   else
       {
	sufix[index]=runCode++;
	prefix[index]=curCode;
	stack[index]=pixel;
       }
   curCode=pixel;
}
return OK;
}

	// 樠 ६ । ᦠ⨥.

int	pascal magGifInitCo
	( void )
{
int k;
rc=_write(hGifW,&bitPerPixel,1);
if ( rc==-1 ) return NO_WRITE;
buffer[0]=0;
ClearCode=1<<bitPerPixel;
EOFCode=ClearCode+1;
runCode=EOFCode+1;
runningBits=bitPerPixel+1;
maxCodeMult2=1<<runningBits;
curBufferShift=0;
codeBuffer=0;
curCode=FIRST_CODE;
memset(prefix,0xff,TABLE_SIZE*sizeof(word));
memset(sufix,0xff,TABLE_SIZE*sizeof(word));
memset(stack,0xff,TABLE_SIZE*sizeof(byte));
rc=magGifCoCode(ClearCode);
if ( rc==-1 ) return NO_WRITE;
return OK;
}

int	pascal magWriteHeaderGif
	( char * fileName, gifHeader * gh, char * buf_pal )
{
char label[8];
int i, rc;
strcpy(label,GIF_TITLE);
hGifW=open(fileName,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY, S_IWRITE );
if ( hGifW==-1 ) return NO_WRITE;
rc=_write(hGifW,label,6);
if ( rc==-1 ) return NO_WRITE;
rc=_write(hGifW,gh,sizeof(gifHeader));
if ( rc==-1 ) return NO_WRITE;
for ( i=0; i<LEN_PAL_256; i++ )
	buf_pal[i]<<=2;
rc=_write(hGifW,buf_pal,LEN_PAL_256);
if ( rc==-1 ) return NO_WRITE;
return hGifW;
}

int	pascal magWriteGif
	( int h, gifImageHeader * gih, char far * image )
{
char far * b;
int rc;
word y;
b=image;
hGifW=h;
rc=_write(hGifW,gih,sizeof(gifImageHeader));
if ( rc==-1 ) return NO_WRITE;
bitPerPixel=gih->bit+1;
if ( prefix==0 ) magGifMem();
rc=magGifInitCo();
if ( rc==-1 ) return NO_WRITE;
for ( y=0; y<gih->height; y++)
{
	rc=magGifCoLine ( b, gih->width);
	if ( rc<0 ) return rc;
	b=addAddr(b, gih->width);
}
magGifCoCode(curCode);
magGifCoCode(EOFCode);
magGifCoCode(FLUSH_OUT);
_close(hGifW);
return OK;
}

