//
//		ᨬ .. ⥪ 䥩 DISP.
//		Copyright 1992. V1.
//
//		㭪樨 ࠡ  ᯨ᪠.
//
#include <alloc.h>
#include <io.h>
#include <mem.h>
#include "list.h"

static void * v;
static int i, j;
	//
	// ⠢   
	//
int  pascal InsertItem( List * l, int index, void *item) {
if( index < NULL ) return NO_ELEMENT;
if( l->count == l->limit )
	if ( SetList( l,(l->count + l->delta)) == NO_MEMORY ) return NO_MEMORY;
if ( !l->items ) return NO_ELEMENT;
memmove( &l->items[index+1], &l->items[index], (l->count-index)*sizeof(void *) );
l->count++;
l->items[index] = item;
if ( l->size_item ) {
	if ( !( l->items[index]=malloc( l->size_item ) ) ) {
		l->items[index] = item;
		return NO_MEMORY;
	}
	memcpy( l->items[index], item, l->size_item );
}
return OK;
}
	//
	// ⠢    ᯨ᪠
	//
int  pascal AddItem( List * l,  void *item ) {
j = l->count;
i=InsertItem( l, l->count, item );
if ( i== OK ) return j;
else return i;
}
	//
	//    
	//
int pascal ChangeItemN ( List * l, int index, void * item ) {
if ( (index<NULL) || (index>=l->count) ) return NO_ELEMENT;
if ( l->size_item )
	memcpy( l->items[index], item, l->size_item );
else l->items[index]=item;
return OK;
}
	//
	//    ᯨ᪥
	//
int  pascal FindItem( List * l, void *item) {
for( i = NULL; i < l->count; i++ )
	if( item == l->items[i] )
	    return i;
return NO_ELEMENT;
}
	//
	// ࠥ      ࠧ ᯨ᪠
	//
int  pascal RemoveItemN( List * l,  int index ) {
if ( (index<NULL) || (index>=l->count) ) return NO_ELEMENT;
if ( (l->size_item!=0) && (l->items[index]!=0) )
	free(l->items[index]);
l->count--;
memmove( &l->items[index], &l->items[index+1], (l->count-index)*sizeof(void *) );
return OK;
}
	//
	// 㤠 㪠⥫  
	//
int pascal RemoveItem( List * l, void * item ) {
i=FindItem( l, item );
if ( i == NO_ELEMENT ) return NO_ELEMENT;
return RemoveItemN( l, i );
}
	//
	// 㤠  㪠⥫  ᯨ᪥
	//
void pascal RemoveList ( List * l ) {
if ( l->size_item!=0 )
{
  for ( i=0; i<l->count; i++ )
	if ( l->items[i]!=0 )
		free(l->items[i]);
}
l->count=NULL;
}
	//
	// 㪠⥫    
	//
void * pascal Item ( List * l, int index ) {
if ( (index<NULL) || (index>=l->count) ) return (void*)NO_POINTER;
return l->items[index];
}
	//
	//    
	//
int pascal SearchIndex(	List * l, void * item,
	int (*fcmp)(const void*, const void*) ) {
int d=0, h=l->count-1, i, c;
while ( d <= h ) {
	i=(d+h)>>1;
	c=fcmp( l->items[i], item );
	if ( c < 0 ) d=i+1;
	else {
		h=i-1;
		if ( c==0 ) d=i;
	}
}
return d;
}
	//
	// 㤠     ᢮ 
	//
int  pascal FreeItemN( List * l,  int index ) {
v = Item ( l, index);
if ( v == (void*)NO_POINTER ) return NO_ELEMENT;
RemoveItemN( l, index );
if ( v ) free( v );
return OK;
}
	//
	// 㤠   ᢮ 
	//
int  pascal FreeItem( List * l,  void * item ) {
if( RemoveItem( l, item ) == NO_ELEMENT ) return NO_ELEMENT;
if ( item ) free( item );
return OK;
}
	//
	// 㤠  ᯨ᮪
	//
void  pascal FreeList( List * l ) {
if ( l->size_item )
	for( i =  NULL; i < l->count; i++ )
		if ( l->items[i] ) free( l->items[i] );
if ( l->items ) free( l->items );
l->count = l->limit = l->delta = l->size_item = NULL;
l->items = NULL;
}
	//
	//   㫥 㪠⥫
	//
void  pascal PackList( List * l ) {
void **curDst = l->items;
void **curSrc = l->items;
void **last = l->items + l->count;

while( curSrc < last )	{
	if( *curSrc != 0 )
	    *curDst++ = *curSrc;
	curSrc++;
}
}

int  pascal SetList( List * l, int aLimit) {
void **aItems;
if( aLimit < l->count )
	aLimit =  l->count;
if( aLimit > MaxSizeList)
	aLimit = MaxSizeList;
if( aLimit != l->limit )	{
	if (aLimit == 0 )
	    aItems = 0;
	else
	    {
	    aItems =(void**) malloc(aLimit*sizeof(void *));
	    if ( !aItems ) return NO_MEMORY;
	    if( l->count !=  0 )
		memcpy( aItems, l->items, l->count*sizeof(void *) );
	    }
	if ( l->items ) free(l->items);
	l->items =  aItems;
	l->limit =  aLimit;
	}
return OK;
}
	//
	//  ᯨ᮪
	//
int pascal ReadList ( List * l, FILE * f ) {
int e;
if ( f == 0 ) return NO_FILE;
FreeList ( l );
fread ( l, sizeof(int) * 4, 1, f );
if ( ferror(f)!=0 ) return NO_READ;
i=l->limit; l->limit=NULL; e=l->count; l->count=NULL;
if ( SetList ( l, i ) == NO_MEMORY ) return NO_MEMORY;
if ( !v ) free( v );
if ( ( v=malloc(l->size_item) ) == NULL ) return NO_MEMORY;
for ( i = NULL; i < e; i++ ) {
	j=fread ( v, l->size_item, 1, f );
	if ( ferror(f)!=0 ) return NO_READ;
	if ( j == NULL ) break;
	if ( InsertItem ( l, i, v ) != OK ) return NO_MEMORY;
}
return OK;
}
	//
	//  ᯨ᮪
	//
int pascal WriteList ( List * l, FILE * f ) {
if ( !l->size_item ) return NO_ELEMENT;
if ( f == 0 ) return NO_FILE;
fwrite ( l, sizeof(int)*4, 1, f );
if ( ferror(f)!=0 ) return NO_WRITE;
PackList( l );
for ( i = NULL; i < l->count; i++ )
	if ( l->items[i] )
	fwrite ( l->items[i], l->size_item, 1, f );
	if ( ferror(f)!=0 ) return NO_WRITE;
return OK;
}
