#include <stdio.h>
#include <io.h>
#include <alloc.h>
#include <string.h>
#include "lib.h"

static List * lt;
static int h, rc;
static RecLib * rl;
static RecLib rec;

Lib * pascal libNew
	( void )
{
Lib * l=0;
l=(Lib*)malloc(sizeof(Lib));
if ( l==0 ) return l;
lt=&(l->lf);
l->buf=0;
lt->count=lt->limit=0;
lt->delta=10; lt->size_item=sizeof(RecLib); lt->items=0;
SetList(lt,50);
return l;
}

void pascal libFree
	( Lib * l )
{
if ( l==0 ) return;
free(l);
}

int pascal libCreate
	( Lib * l, char * name, word len_buf )
{
if ( l==0 ) return NO_POINTER;
l->fr=fopen(name,"w+b");
if ( l->fr==0 ) return NO_FILE;
setvbuf(l->fr,l->buf,_IOFBF,len_buf);
return OK;
}

int pascal libOpen
	( Lib * l, char * name, word len_buf )
{
char n[5];
long off;
int h;

if ( l==0 ) return NO_POINTER;
l->fr=fopen(name,"r+b");
if ( l->fr==0 ) return NO_FILE;
setvbuf(l->fr,l->buf,_IOFBF,len_buf);
fseek(l->fr,-4L,SEEK_END);
fread(n,4,1,l->fr);
if ( memcmp(n,LIB_IDEN,4)!=0 )
{
	fclose(l->fr);
	return NO_FILE;
}
fseek(l->fr,-8L,SEEK_END);
fread(&off,4,1,l->fr);
fseek(l->fr,off,SEEK_SET);
lt=&(l->lf);
rc=ReadList(lt,l->fr);
if ( rc<0 ) return rc;

fseek(l->fr,0L,SEEK_SET);
h=fileno(l->fr);
rc=chsize(h,off);

return OK;
}


int pascal libClose
	( Lib * l )
{
long off;
if ( l==0 ) return NO_FILE;
fflush(l->fr);
fseek(l->fr,0L,SEEK_END);
off=ftell(l->fr);
lt=&(l->lf);
rc=WriteList(lt,l->fr);
fwrite(&off,4,1,l->fr);
fwrite(LIB_IDEN,4,1,l->fr);
fflush(l->fr);
fclose(l->fr);
FreeList(lt);
return OK;
}


int pascal libFind
	( Lib * l, char * name )
{
register int i;
if ( l==0 ) return NO_FILE;
lt=&(l->lf);
for ( i=0; i<lt->count; i++ )
{
	rl=(RecLib*)lt->items[i];
	if ( strcmp(name,rl->name)==0 )
	{
		return i;
	}
}
return -1;
}

int pascal libSeek
	( Lib * l, char * name )
{
int i;
if ( l==0 ) return NO_FILE;
i=libFind(l,name);
if ( i==-1 ) return NO_FILE;
fseek(l->fr,rl->offset,SEEK_SET);
return i;
}


int pascal libAdd
	( Lib * l, char * name )
{
long of;
int i;
if ( l==0 ) return NO_FILE;
if ( strlen(name)>15 ) name[15]=0;
i=libFind(l,name);
if ( i!=-1 ) return NO_FILE;
fseek(l->fr,0L,SEEK_END);
of=ftell(l->fr);
memset(&rec,0,sizeof(RecLib));
strcpy(rec.name,name);
rec.offset=of;
rec.len=0L;
lt=&(l->lf);
rc=AddItem(lt,&rec);
return rc;
}


int pascal libSetLen
	( Lib * l, char * name, long len )
{
int i;
if ( l==0 ) return NO_FILE;
if ( strlen(name)>15 ) name[15]=0;
i=libFind(l,name);
if ( i==-1 ) return NO_FILE;
rl->len=len;
return i;
}


int pascal libDelete
	( Lib * l, char * name )
{
static char buf_del[512];
register int i;
long of_wr, of_rd, len, new_len, of;
int h;

if ( l==0 ) return NO_FILE;

// 1. 2.९ 筮 3. ४஢  
// 4.  䠩

fflush(l->fr);
fseek(l->fr,0L,SEEK_END);
new_len=ftell(l->fr);
i=libSeek(l,name);
if ( i==-1 ) return NO_FILE;
len=rl->len;
lt=&(l->lf);
RemoveItemN(lt,i);
//
new_len-=len;
of=of_wr=ftell(l->fr);
of_rd=of_wr+len;
while ( 1 )
{
	if ( feof(l->fr)!=0 ) break;
	if ( ferror(l->fr)!=0 ) return NO_WRITE;
	fseek(l->fr,of_rd,SEEK_SET);
	rc=fread(buf_del,1,512,l->fr);
	if ( feof(l->fr)!=0 ) break;
	fseek(l->fr,of_wr,SEEK_SET);
	fwrite(buf_del,rc,1,l->fr);
	fflush(l->fr);
	of_wr+=rc; of_rd+=rc;
	if ( rc!=512 ) break;
}
//
for ( i=0; i<lt->count; i++ )
{
	rl=(RecLib*)lt->items[i];
	if ( rl->offset>=of )
	   rl->offset-=len;
}
fflush(l->fr);
h=fileno(l->fr);
rc=chsize(h,new_len);
if ( rc!=0 ) return NO_WRITE;
return OK;
}

int pascal libAddBuf
	( Lib * l, char * name, char * buf, word len )
{
rc=libAdd(l,name);
if ( rc<=-1 ) return rc;
fwrite(buf,len,1,l->fr);
rc=libSetLen(l,name,len);
return rc;
}

long pascal libReadBuf
	( Lib * l, char * name, char * buf )
{
rc=libSeek(l,name);
if ( rc<=-1 ) return rc;
fread(buf,rl->len,1,l->fr);
if ( ferror(l->fr)!=0 ) return NO_READ;
return rl->len;
}


char * pascal libSeekNumber
	( Lib * l, word n )
{
if ( l==0 ) return 0;
lt=&(l->lf);
if ( n>=lt->count ) return 0;
rl=(RecLib*)lt->items[n];
fseek(l->fr,rl->offset,SEEK_SET);
return rl->name;
}


word pascal libCount
	( Lib * l )
{
if ( l==0 ) return 0;
lt=&(l->lf);
return lt->count;
}

