#ifndef __MAGLIB_H
#define __MAGLIB_H

#include <stdio.h>

#ifndef __MAGTYPE_H
#include "magtype.h"
#endif

typedef struct
{
	char vesa[4];
	char ver1;
	char ver2;
	char * far name;
	char cap[4];
	int * far modes;
	int mem;
	char res[240];
} VESAinfo;

typedef struct
{
	word sup:1;
	word is:1;
	word bios:1;
	word color_mono:1;
	word grap_text:1;
	word attr_res:11;
	byte a_exists:1;
	byte a_read:1;
	byte a_write:1;
	byte a_res:5;
	byte b_exists:1;
	byte b_read:1;
	byte b_write:1;
	byte b_res:5;
	word gran_k;
	word size_k;
	word seg_a;
	word seg_b;
	word far * pos_win;
	word bytes_line;
	word width;
	word height;
	byte width_char;
	byte height_char;
	byte planes;
	byte bit_per_pixels;
	byte banks;
	byte model;
	byte bank_k;
	char res[230];
} VESAmodeInfo;

//  䠩 PCX
typedef struct {
	byte	id;		// ᥣ 10
	byte	ver;		// 
	byte	encod;		// ⮤ ᦠ = 1  RLE
	byte	bitpx;		//   
	word	xl, yl;		// ࠧ ⨭ ( ⥫쭮 )
	word	xh, yh;
	word	xRes, yRes;	// ࠧ襭 ᯫ
	byte	palette[48];	// 
	byte	res1;
	byte	nplanes;	// ⢮ ᪮⥩
	word	bytepl;		//   ப
	word	palInfo;	// ଠ  
				// ( 1-梥⭮, 2-⥭ ண )
	word	shres;		// ࠧ襭 ᪠
	word	svres;
	byte	res2[54];	// 䨫
} pcxHeader;

typedef struct {
	char * pat;
	word w_pat;
	word h_pat;
} Pattern;

typedef struct {
	char far * sp;
	char far * fon;
	char far * buf;
	char far * tab_shadow;
	char far * fon1;
	word x, y, w, h;
	word fonColor;
	word shadowColor;
	byte set:1; // - 1 ⠭  ࠭
	byte mem:1; // - 1 뤥 
	byte shadow:1; // 1 -  ⥭ 뢮
	byte res:5;
} Sprite;

#define LEN_PAL_256  	768

// VESA MODE
#define MODE_640_400_256	0x100
#define MODE_640_480_256	0x101
#define MODE_800_600_16		0x102
#define MODE_800_600_256	0x103
#define MODE_1024_768_16	0x104
#define MODE_1024_768_256	0x105
#define MODE_1280_1024_16	0x106
#define MODE_1280_1024_256	0x107


#define SCREEN_OFF		0
#define SCREEN_ON		1
#define MAX_BUF_FILE		5000
#define NO_ROTATE 		0
#define ROTATE_VER		1
#define ROTATE_HOR		2
#define ROTATE_VH		3

extern VESAinfo vi;
extern VESAmodeInfo vmi;
extern char bufPals[800];
extern int i_buf;

#ifdef __cplusplus
extern "C" {
#endif

	//
	// ⠭ ᪮ ०  
	//
int	pascal magSetGameMode
	( word r );
	//
	// ⠭ ⥪⮢ ०
	//
void	pascal magSetDosMode
	( void );
	//
	// ⨥ 
	//
void	pascal magGetPals
	( void );
	//
	// ⠭ 
	//
void	pascal magSetPals
	( void );
	//
	//  室 
	//
void	pascal magWaitRetr
	( void );
	//
void	pascal _delay
	( long del );
	//
	// ⠭ 
	//
void	pascal magSetDAC
	( void );
	//
	// ⠭ 
	//
void	pascal setDAC
	( byte n, byte r, byte g, byte b );
	//
	//  Cirrus
	//
byte	pascal magFindCirrus
	( void );
	//
	//  Trident
	//
byte	magFindTrident
	( void );

	//
	// 樨  ⥪饩 窮
	//
void	pascal magXY
	( word x, word y );
word	pascal magPtrX
	( void );
word	pascal magPtrY
	( void );
word	pascal magMaxX
	( void );
word	pascal magMaxY
	( void );
word	pascal magMaxColor
	( void );
	//
	// 뢮 אַ㣮쭨
	//
void	pascal magRect
	( word w, word h, word color );
	//
	// 뢮 ࠦ
	//
void	pascal magSetImage
	( word w, word h, char far * image );
	//
	// ⥭ ࠦ
	//
void	pascal magGetImage
	( word w, word h, char far * image );
	//
	// ஫ ࠦ
	//
void	pascal magScrollScreen
	( word w, word h, int dw, int dh );
	//
	// 뢮  ࠦ
	//
void	pascal magSetImagePart
	( word w, word h, char far * image,
	  word x_i, word y_i, word w_i, word h_i );
	//
	// ⥭  ࠦ
	//
void	pascal magGetImagePart
	( word w, word h, char far * image,
	  word x_i, word y_i, word w_i, word h_i );
	//
	// 뢮 ࠦ  䥪⮬ Slide
	//
void	pascal magSetImageSlide
	( word w, word h, char far * image,
	  byte type, word grain, word del ); // ⨯ 0 - ᭨ , 1 - ᢥ 
	//
	// 뢮 ࠦ  䥪⮬ Gate
	//
void	pascal magSetImageGate
	( word w, word h, char far * image,
	  byte type, word grain, word del ); // ⨯ 0 - close, 1 - open
	//
	//  ⭮  ப
	//
void	pascal setByte( unsigned char far * des, unsigned char data,
		unsigned int count ) ;
	//
	// 뫪 ப  ⠬
	//
void	pascal copyByte( unsigned char far * sou, unsigned char far * des,
		 unsigned int len ) ;
	//
char far *  pascal addAddr
        ( char far * a, long count );
char far *  pascal subAddr
        ( char far * a, long count );
char far * pascal incAddr
        ( char far * a );
char far * pascal decAddr
        ( char far * a );
        //
	// 뢮 蠡  ᨢ
	//
void	pascal magRectPattern
	( word w, word h, Pattern * p );
	//
	//  梥  
	//
byte	pascal magFindColor
	( char * pals, byte red, byte green, byte blue, byte filtr );
	//
	//  /  ࠭
	//
void	pascal magOnOff // 0 - 
	( byte on_off, char * pals );
	//
	// 饭 ⨭
	//
void	pascal magRotateImage
	( word w, word h, char far * sou, char far * des, byte rot );
	//
	//  ࠩ
	//
void	pascal magSprImage
	( word w, word h,
	  char far * spr_sou, char far * fon_des, byte fonColor );
	//
	//  ࠩ  ⥭
	//
void	pascal magSprImageShadow
	( word w, word h,
	  char far * spr_sou, char far * fon_des, byte fonColor,
	  char far * tab, byte shColor );
	//
	// ଠ
	//
char far * hugeAddr
	( char far * );
	//  㭪
	// len -  㭪, nptr - ⥪饥 祭,
	// maxn - . 祭
word	posRun
	( word len, word nptr, word maxn );
	// ਧ⠫ ࠤ, ᪠
	//   - w, len -  grad, grad - 梥
void	magHorizGrad
	( word x, word y, word w, word len, char * grad );
	// אַ㣮쭨 ਧ⠫쭮 ࠤ
	//   - w, len -  grad, grad - 梥
void	magRectHGrad
	( word w, word h, word len, char * grad );
	// אַ㣮쭨 ⨪쭮 ࠤ
	//   - w, len -  grad, grad - 梥
void	magRectVGrad
	( word w, word h, word len, char * grad );
	//
	// 뢮 ࠦ
	//
void	pascal magQuickImage
	( word w, word h, char far * image );
	//
	// 뢮 ࠦ
	//
void	pascal magQuickImagePart
	( word w, word h, char far * image,
	  word x_i, word y_i, word w_i, word h_i );
	//
	// ஢ ஢ ᫥ ࠢ, ᢥ 
	//
void	CopyImageScreen
	( unsigned char far * sou,//
		 unsigned char far * des,
		 unsigned int len_s,
		 unsigned int len_d,
		 unsigned int w,// ᫮ ⮢
		 unsigned int h );

	// ( MAGPCX.C )

int	pascal magReadHeaderPcx
	( char * nf, pcxHeader * ph, char * buf_pal );
int	pascal magReadPcx
	( int hPcx, pcxHeader * ph, char far * image );
int	pascal magShowPcx
	( int hPcx, pcxHeader * ph );
int	pascal magWritePcx
	( char * nf, word w, word h, char * buf_pal, char far * image );
int	pascal magWriteScrPcx
	( char * nf, word w, word h );

	// ( MAGFONT.C )

int	pascal magReadFont ( char * FileFont );
void	pascal magResetFont
	( void );
word	pascal magWidthFont
	( void );
word	pascal magHeightFont
	( void );
void	pascal magChar
	( char ch, word color );
void	pascal magStr
	( char * str, word color );
void pascal	drawRec
	( word x, word y, word w, word h, word fon );
void pascal	drawText
	( word x, word y, word color, char * s );
void pascal	gputs
	( word x, word y, word attr, char * s );
void pascal	gputc
	( word x, word y, word attr, char c );
void	gprintf
	( word x, word y, word attr, char *fmt, ... );

	// ( MAGSPR.C )

	//
	// ନ஢  ࠩ
	//
int	pascal magNewSpr
	( Sprite * s, word w, word h, word fonColor, char far * sp );
	//
	// ⠭ ⥭  ࠩ
	//
void	pascal magSprShadow
	( Sprite * s, char * pallete, word colorShadow, int r, int g, int b, byte filtr );
	//
	//  ࠩ
	//
void	pascal magDelSpr
	( Sprite * s );
	//
	// 뢮 ࠩ
	//
void	pascal magSetSpr
	( Sprite * s, byte lr ); // lr=0 - ᫥ ࠢ
	//
	//  ࠩ  ࠭
	//
void	pascal magRemSpr
	( Sprite * s );
	//
	//  ᫥⥫쭮 ࠩ⮢
	//
void	pascal magAnimate
	( Sprite * s, char far * f[], word ptr_f, byte lr );
	//
	// ⠭ ࠩ
	//
void	pascal magRestoreSpr
	( Sprite * s, word x, word y, word w, word h, byte lr );
	//
	// ⮬᪮ ⠭ ࠩ
	//
void	pascal magBurnSpr
	( Sprite * s, byte lr );
	//
	//  ࠦ ࠩ  㣮 ࠦ
	//
byte pascal magSetImageSpr
	( Sprite * s, byte lr,
	  char far * im, word x, word y, word w, word h );


	// (MAGFILE.C)
	//
int	pascal _read_buf
	( int h, char * buf, word count );

	//
	// ZIP.C
int	pascal zip_buf
	( FILE *f_output, long len, char far * buf );

int	pascal unzip_buf
	( FILE *f_input, long len, char far * buf );
int	pascal magShowZip
	( FILE * f, word x, word y, word w, word h );

	//
	// (MAGBUF.C)
	//
	// ஢   ࠦ
	//
void	pascal magSetBufImage
	( char far * buf, word w, word h,
	  word x, word y,
	  char far * im, word w_im, word h_im );
	//
	// ஢   אַ㣮쭨
	//
void	pascal magSetBufRect
	( char far * buf, word w, word h,
	  word x, word y,
	  byte color, word w_r, word h_r );


// PAL.C
void	pascal magShiftPal
	( char * pals, char * tab,
	  int r, int g, int b, byte filtr ); // ᤢ ⥪饩   ⠡
void	pascal magTabImage
	( char far * bufImage, word w, word h, char * tab );
	 // ४஢ ࠦ

// MRAND.C -  砩 ᥫ
void	_srand
	( unsigned int seed ); // ⠭
int	_rand
	( void ); // 砩 ᫮
int	_random
	( int num ); // 砩 ᫮  
void	_randomize
	( void ); // 樠 ६
#ifdef __cplusplus
}
#endif

#endif
