#include <dos.h>
#include <mem.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <alloc.h>
#include "maglib.h"

extern word ptr_x, ptr_y, max_x, max_y, max_color;

int	pascal magReadHeaderPcx
	( char * nf, pcxHeader * ph, char * buf_pal )
{
int hPcx, rc, err=0, i;
byte id_pal;
hPcx=_open ( nf, O_RDONLY | O_BINARY );
if ( hPcx == -1 ) return NO_FILE;
rc = _read ( hPcx, ph, sizeof ( pcxHeader ) );
if ( rc == -1 ) { err=NO_READ; goto FIN; }
if ( ph->bitpx!=8 ) return hPcx;
lseek(hPcx,-769L,SEEK_END);
rc=_read(hPcx, &id_pal, 1);
if ( rc == -1 ) { err=NO_READ; goto FIN; }
if ( id_pal!=0xC && id_pal!=0xA ) return hPcx;
rc=_read(hPcx, buf_pal, 768);
if ( rc == -1 ) { err=NO_READ; goto FIN; }
if ( id_pal==0xC )
   for ( i=0; i<768; i++ ) buf_pal[i]=(buf_pal[i]>>2)&0x3F;
FIN:
if ( err )
   { _close(hPcx) ;hPcx=err; }
return hPcx;
}

extern	char _bufPlanes[2000];

int	pascal magReadPcx
	( int hp, pcxHeader * ph, char far * image )
{
word i, j, w, h, bl;
byte ch, rep;
char * im;
int rc;

im=image;
if ( hp == -1 ) return NO_FILE;
lseek(hp,sizeof(pcxHeader)*1L,SEEK_SET);
w=ph->xh-ph->xl+1; h=ph->yh-ph->yl+1;
i_buf=-1; bl=ph->nplanes*ph->bytepl;

for ( i=0; i<h; i++ )
{
   for ( j=0; j<bl; j+=rep )
   {
	_read_buf(hp,&ch,1);
	rep=1;
	if ( (ch&0xC0)==0xC0 )
	{
	   rep=ch&0x3f;
	   _read_buf(hp,&ch,1);
	}
	setByte((im+j),ch,rep);
   }
   im=addAddr(im,w);
}
return OK;
}

int	pascal magShowPcx
	( int hp, pcxHeader * ph )
{
word i, j, w, h, h_s, bl;
byte ch, rep;
char * im;
int rc;

im=_bufPlanes;
if ( hp == -1 ) return NO_FILE;
lseek(hp,sizeof(pcxHeader)*1L,SEEK_SET);
w=ph->xh-ph->xl+1; h=ph->yh-ph->yl+1;
i_buf=-1; bl=ph->nplanes*ph->bytepl;
if ( ph->yh>max_x ) h_s=max_x-ph->yl+1;
else h_s=h;

for ( i=0; i<h_s; i++ )
{
   for ( j=0; j<bl; j+=rep )
   {
	_read_buf(hp,&ch,1);
	rep=1;
	if ( (ch&0xC0)==0xC0 )
	{
	   rep=ch&0x3f;
	   _read_buf(hp,&ch,1);
	}
	setByte((im+j),ch,rep);
   }
   magXY(ph->xl,ph->yl+i);
   magSetImage(w,1,(char far *)im);
}
return OK;
}

int	pascal magWritePcx
	( char * nf, word w, word h, char * buf_pal, char far * image )
{
pcxHeader ph;
int hPcx, rc;
word y;
byte far * mb;
byte * mpb;
char far * im;
int buf_full, pack_count, err;
byte rep, cur_byte;

ph.id=0xA; ph.ver=5; ph.encod=1;
ph.xl=ph.yl=0; ph.xh=w-1; ph.yh=h-1;
ph.bitpx=8; ph.xRes=max_x; ph.yRes=max_y; ph.nplanes=1;
ph.bytepl=w; ph.palInfo=1;

err=OK;
hPcx=open(nf,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY, S_IWRITE );
if ( hPcx==-1 ) return NO_WRITE;
rc=_write(hPcx,&ph,sizeof(pcxHeader));
if ( rc==-1 ) { err=NO_WRITE; goto Fin; }

im=image;

for ( y=0; y<h; y++ )
{
   mb=(byte far *)im;
   mpb=_bufPlanes;
   buf_full=w;
   pack_count=0;
   for ( ; ; )
   {
	if ( buf_full==0 )
		break;
	cur_byte=*mb++;
	rep=1;
	buf_full--;
	while ( (*mb==cur_byte) && (buf_full>0) )
	{
	   mb++; rep++; buf_full--;
	   if ( buf_full==0 )
	      break;
	   if ( rep==63 )
	      break;
	}
	if ( rep>1 )
	{
	   *mpb=(0xC0|rep); mpb++;
	   *mpb=cur_byte; mpb++;
	   pack_count+=2;
	   continue;
	}
	if ( cur_byte<0xC0 )
	{
	    *mpb=cur_byte; mpb++;
	    pack_count++;
	    continue;
	}
	*mpb=0xC1; mpb++;
	*mpb=cur_byte; mpb++;
	pack_count+=2;
   }
   rc=_write(hPcx,_bufPlanes,pack_count);
   if ( rc==-1 ) { err=NO_WRITE; goto Fin; }
   im=addAddr(im,w);
}

cur_byte=0xC;
_write(hPcx,&cur_byte,1);
for ( y=0; y<LEN_PAL_256; y++ )
	buf_pal[y]<<=2;
_write(hPcx,buf_pal,LEN_PAL_256);

Fin:
_close(hPcx);
return err;
}

int	pascal magWriteScrPcx
	( char * nf, word w, word h )
{
pcxHeader ph;
int hPcx, rc;
word y, old_ptr_y;
byte far * mb;
byte * mpb;
char * image=0;
int buf_full, pack_count, err;
byte rep, cur_byte;

if ( ptr_x+w>max_x ) w=max_x-ptr_x+1;
if ( ptr_y+h>max_y ) h=max_y-ptr_y+1;
old_ptr_y=ptr_y;

ph.id=0xA; ph.ver=5; ph.encod=1;
ph.xl=ptr_x; ph.yl=ptr_y; ph.xh=ptr_x+w-1; ph.yh=ptr_y+h-1;
ph.bitpx=8; ph.xRes=max_x; ph.yRes=max_y; ph.nplanes=1;
ph.bytepl=w; ph.palInfo=1;

err=OK;
hPcx=open(nf,O_WRONLY | O_CREAT | O_TRUNC | O_BINARY, S_IWRITE );
if ( hPcx==-1 ) return NO_WRITE;
rc=_write(hPcx,&ph,sizeof(pcxHeader));
if ( rc==-1 ) { err=NO_WRITE; goto Fin; }
image=(char *)malloc(2000);
if ( image==0 ) { err=NO_MEMORY; goto Fin; }

for ( y=0; y<h; y++ )
{
   magGetImage(w,1,image);
   mb=(byte *)image;
   mpb=_bufPlanes;
   buf_full=w;
   pack_count=0;
   for ( ; ; )
   {
	if ( buf_full==0 )
		break;
	cur_byte=*mb++;
	rep=1;
	buf_full--;
	while ( (*mb==cur_byte) && (buf_full>0) )
	{
	   mb++; rep++; buf_full--;
	   if ( buf_full==0 )
	      break;
	   if ( rep==63 )
	      break;
	}
	if ( rep>1 )
	{
	   *mpb=(0xC0|rep); mpb++;
	   *mpb=cur_byte; mpb++;
	   pack_count+=2;
	   continue;
	}
	if ( cur_byte<0xC0 )
	{
	    *mpb=cur_byte; mpb++;
	    pack_count++;
	    continue;
	}
	*mpb=0xC1; mpb++;
	*mpb=cur_byte; mpb++;
	pack_count+=2;
   }
   rc=_write(hPcx,_bufPlanes,pack_count);
   if ( rc==-1 ) { err=NO_WRITE; goto Fin; }
   ptr_y++;
}

cur_byte=0xC;
_write(hPcx,&cur_byte,1);
magGetPals();
for ( y=0; y<LEN_PAL_256; y++ )
	bufPals[y]<<=2;
_write(hPcx,bufPals,LEN_PAL_256);

Fin:
_close(hPcx);
if ( image!=0 ) free(image);
ptr_y=old_ptr_y;
return err;
}
