#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <malloc.h>
#include <io.h>
#include <conio.h>
#include <mem.h>
#include <string.h>
#include <string.h>
#include <dir.h>
#include <ctype.h>
#include "sb.h"
#include "dma.h"


int     basesSB[MAX_BASE_SB]={ 0x210, 0x220, 0x230, 0x240, 0x250, 0x260 };
int	baseAddrSB=0;
int	verSB=0;
char	SixteenBit=0, Stereo=0, MaxFrequency=0, Fifo=0;
char	DMAChannel=1, SbIRQ=7;

static void far interrupt (*OldIRQ)();
volatile int DMA_complete; // 0 - , 1 - 稫
// ६  ࠡ
static unsigned long start;
static unsigned long far * timec=(unsigned long far * )(0x046C);


DMA_Buf dBuf;

	//    SB

unsigned char pascal sbRead
	(void)
{
unsigned int value, p;
//start=*timec;
p=baseAddrSB+0xE;
while (!(inportb(p) & 0x80));
//	if ( (*timec-start)>=2 ) break;
value = inportb((baseAddrSB+0xA));
return value;
}

	//   SB

void pascal sbWrite
	(unsigned char value)
{
unsigned int p;
//start=*timec;
p=baseAddrSB+0xC;
while (inportb(p) & 0x80);
//	if ( (*timec-start)>=2 ) break;
outportb(p, value);
}

	//   SB  㦥

int	pascal sbEnvData
	( InitSB * isb )
{
char *t, *t1, *blaster;
isb->port=0x220; isb->irq=7; isb->dma=1; isb->ver=0x310;

t = getenv("BLASTER");

if ( t == NULL )
	return 0;

blaster = strdup(t);

t = strtok(blaster," \t");
while ( t )
{
	switch(toupper(t[0]))
	{
	    case 'A':
		isb->port = (int)strtol(t+1,&t1,16);
		break;
	    case 'I':
		isb->irq = atoi(t+1);
		break;
	    case 'D':
		isb->dma = atoi(t+1);
		break;
	    case 'T':
		isb->ver = atoi(t+1);
		break;
	    default:
		break;
	}
	t = strtok(NULL," \t");
    }
free(blaster);
return 1;
}


	// ஢ 稥

char pascal sbCheck
	( void )
{
int i, j;
if ( baseAddrSB==0 ) {
for ( j=0; j<MAX_BASE_SB; j++ )
{
baseAddrSB=basesSB[j];
outportb(baseAddrSB+6,1);
delay(10);
outportb(baseAddrSB+6,0);
delay(10);
for(i=0; i<30000; i++ )
	if ( sbRead()==0xAA )
		return 1;
}
 } else
{
outportb(baseAddrSB+6,1);
delay(10);
outportb(baseAddrSB+6,0);
delay(10);
for(i=0; i<30000; i++ )
	if ( sbRead()==0xAA )
		return 1;
}
return 0;
}

	// 

int pascal sbVersion
	( void )
{
char ch, ch1;
sbWrite(0xE1);
ch=sbRead();
ch1=sbRead();
verSB=ch<<8 | ch1;
if ( verSB>=0x200 )
	Fifo=1;
if ( verSB>=0x201 )
	MaxFrequency=1;
if ( verSB>=0x300 )
	Stereo=1;
if ( verSB>=0x301 )
	SixteenBit=1;
return verSB;
}


	// ࠡ稪 뢠

static void far interrupt SBHandler( void )
{
enable();
DMA_complete = 1;

// ⢥
inportb(baseAddrSB+0xE);
outportb(0x20,0x20);
}

	// 樠

int pascal sbSetup
	( int port, int irq, int dma )
{
static char init=0;
unsigned long physical;
unsigned char im, tm;

if ( init==1 ) return 0;
switch ( port )
{
case 0x210: case 0x220: case 0x230: case 0x240: case 0x250: case 0x260:
	break;
default: port=0;
}
baseAddrSB=port;
if ( dma<0 || dma>3 )
	DMAChannel=1;
else	DMAChannel=dma;
if ( irq!=2 && irq!=3 && irq!=5 && irq!=7 )
	SbIRQ=7;
else	SbIRQ=irq;
if ( sbCheck()!=1 ) return 0;
init=1;
sbVersion();
dBuf.len=10002;
if ( dmaMalloc(&dBuf)==0 )
	return 0;

disable();
OldIRQ = getvect(0x08 + SbIRQ);
setvect(0x08 + SbIRQ,SBHandler);
DMA_complete = 1;
im = inportb(0x21);
tm = ~(1 << SbIRQ);
outportb(0x21,im & tm);
enable();

sbWrite(ON_SOUND_SB);

return verSB;
}

	//  SB

void pascal sbReset
	( void )
{
unsigned char i;
inportb(baseAddrSB+0xE);
outportb(0x20,0x20);

dmaFree(&dBuf);
sbWrite(OFF_SOUND_SB);
sbWrite(HALT_DMA_8);

disable();
i = inportb(0x21);
outportb(0x21, i | (1 << SbIRQ));
setvect(0x08 + SbIRQ,OldIRQ);
enable();
}

	// ⠭ 

unsigned int pascal sbRate
	( unsigned int rate )
{
unsigned char tc;

if ( MaxFrequency==0 || rate<22528 )
{
    if ( rate<5000 ) rate=5000;
    if ( rate>22528 ) rate=22528;
    tc = (unsigned char)(256 - (1000000/rate));
    rate = (unsigned int)(1000000/(256-tc));
}
else
{
    if ( rate<5000 ) rate=5000;
    if ( rate>45056 ) rate=45056;
    tc = (unsigned char)(hi((unsigned int)(65536-(256000000L/rate))));
}
sbWrite(TIME_CONSTANT);
sbWrite(tc);
return rate;
}

	// ந뢠 롮ન

void pascal sbPlay
	( char far * raw, unsigned int len )
{
int MaskPort, ClrPort, ModePort, ModeDMA, CountPort, PagePort,
	BaseAddrPort;
int pageports[4]={ 0x87, 0x83, 0x81, 0x82 };
unsigned char l, h;

if ( len==0 ) return;
if ( len>dBuf.len ) len=dBuf.len;

sbWrite(ON_SOUND_SB);
_fmemcpy(dBuf.dma,raw,len);

// ன ࠡ稪
DMA_complete=0;
l=lo(len-1); h=hi(len-1);

// ன DMA
MaskPort=0x0A; ClrPort=0xC; ModePort=0xB;
ModeDMA=0x48+DMAChannel;
CountPort=1+DMAChannel*2;
BaseAddrPort=DMAChannel*2;
PagePort=pageports[DMAChannel];

outportb(MaskPort, 4 + DMAChannel);
outportb(ClrPort, DMAChannel );
outportb(ModePort, ModeDMA );
outportb(BaseAddrPort,dBuf.lo_off);
outportb(BaseAddrPort,dBuf.hi_off);
outportb(PagePort,dBuf.page);
outportb(CountPort,l);
outportb(CountPort,h);
outportb(MaskPort, DMAChannel );

// ன DSP
if ( MaxFrequency==0 )
{
    sbWrite(DMA_8_BIT_DAC_LO);
    sbWrite(l);
    sbWrite(h);
}
else
{
    sbWrite(SET_LEN_DMA_8_BIT);
    sbWrite(l);
    sbWrite(h);
    sbWrite(DMA_8_BIT_DAC_HI);
}
//////////
}


unsigned int pascal DmaCount
	 ( void )
{
unsigned int x;
x=inportb(0x03);
x|=inportb(0x03)<<8;
if(x==0xFFFF)
 inportb(baseAddrSB+0xE);
return(x);
}

	// ﭨ ந

char pascal sbStatePlay
	( void )
{
if ( DMA_complete==0 ) return 0;
//if ( DmaCount()!=0xffff ) return 0;
else return 1;
}

void pascal sbWriteMixer
	( char index, char val )
{
outportb(baseAddrSB+4,index);
outportb(baseAddrSB+5,val);
}


char pascal sbReadMixer
	( char index )
{
outportb(baseAddrSB+4,index);
return inportb(baseAddrSB+5);
}

void pascal sbResetMixer
	( void )
{
sbWriteMixer(0,0); // RESET
}


void pascal sbInputMixer
	( char sou, char filtr )
{
char val;
val=(sou<<1)&0x6;
val|=(filtr<<3)&0x38;
sbWriteMixer(0xC,val);
}


void pascal sbOutputMixer
	( char st, char filtr )
{
char val;
val=(st==1)?2:0;
val|=(filtr==1)?0x20:0;
sbWriteMixer(0xE,val);
}


void pascal sbMasterVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x22,val);
}

void pascal sbVoiceVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x04,val);
}

void pascal sbFMVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x26,val);
}

void pascal sbCDVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x28,val);
}

void pascal sbLineVolume
	( char left, char right )
{
char val;
val=right&0xf;
val|=(left<<4)&0xf0;
sbWriteMixer(0x2E,val);
}


void pascal sbMicVolume
	( char vol )
{
char val;
val=vol&0x7;
sbWriteMixer(0xA,val);
}

