#ifndef __SB_H
#define __SB_H


typedef struct
{
	int	port;
	char	irq;
	char	dma;
	int	ver;
} InitSB;

#define WRITE_DATA_SB   	0x10
#define ON_SOUND_SB		0xD1
#define OFF_SOUND_SB		0xD3
#define HALT_DMA_8		0xD0
#define TIME_CONSTANT 		0x40
#define DMA_8_BIT_DAC_LO	0x14
#define DMA_8_BIT_DAC_HI	0x91
#define SET_LEN_DMA_8_BIT	0x48

#define LOW_FILTER	0
#define HIGH_FILTER	1
#define NO_FILTER	2

#define SOURCE_MIC1	0
#define SOURCE_CD	1
#define SOURCE_MIC2	2
#define SOURCE_LINE	3

#define MONO	0
#define STEREO	1

#define USE_FILTER	0
#define BYPASS_FILTER	1

#define MAX_BASE_SB 6

#define lo(value) (unsigned char)((value) & 0x00FF)
#define hi(value) (unsigned char)((value) >> 8)


	//    SB

unsigned char pascal sbRead
	(void);

	//   SB  㦥

int	pascal sbEnvData
	( InitSB * isb );

	// ஢ 稥

char pascal sbCheck
	( void );

	//   SB

void pascal sbWrite
	(unsigned char value);

	//  SB

int pascal sbVersion
	( void );

	// 樠
	//  - 
int pascal sbSetup
	( int port, int irq, int dma );

	//  SB

void pascal sbReset
	( void );

	// ⠭ 
	//  - 
unsigned int pascal sbRate
	( unsigned int rate );

	// ந뢠 롮ન
	// len<dBuf.len
void pascal sbPlay
	( char far * raw, unsigned int len );

	//  ⢠  ந࠭   DMA

unsigned int pascal DmaCount
	 ( void );

	// ﭨ ந
	// 0 - ந뢠, 1 -  ந뢠
char pascal sbStatePlay
	( void );

	// 㭪樨 ன ७  SB

void pascal sbWriteMixer
	( char index, char val );

char pascal sbReadMixer
	( char index );

void pascal sbResetMixer
	( void );

void pascal sbInputMixer
	( char sou, char filtr );

void pascal sbOutputMixer
	( char st, char filtr );

void pascal sbMasterVolume
	( char left, char right );

void pascal sbVoiceVolume
	( char left, char right );

void pascal sbFMVolume
	( char left, char right );

void pascal sbCDVolume
	( char left, char right );

void pascal sbLineVolume
	( char left, char right );

void pascal sbMicVolume
	( char vol );

#endif


