#include <stdio.h>
#include <alloc.h>
#include <string.h>
#include "maglib.h"
#include "key.h"

#define ID_FONT 'MF'

typedef union {
	char far * ptr;
	long	off;
} Offset;

typedef struct {
	word	width;		// ਭ ᨬ
	Offset	o;		// ᬥ饭 ⭮⥫쭮 砫 
} WidthTable;

typedef struct {
	word	id;		// 䨪
	byte	ver;		//  - 0
	word	width;		// ਭ !=0 - ਩
	word	height;		// 
	char	face[21];	//  
	long	len;		//  
	WidthTable wt[256];	// ⠡ ਭ
	Offset	bits;		// 㪠⥫  
	long	res1;
	long	res2;
} MagFont;

MagFont mf;
extern word ptr_x, ptr_y, max_x, max_y;
extern void	pascal magHorizPattern
	( word x, word y, word w, word color, word pat );

	//
	// ⥭ 䮭  
	//
int	pascal magReadMFont
	( char * name, MagFont * mf )
{
FILE * fm;
int rc=OK, i;
long off_bits;

fm=fopen(name,"rb");
if ( fm==0 )
	return NO_FILE;
fread(mf,sizeof(MagFont),1,fm);
off_bits=mf->bits.off;
mf->bits.ptr=0;
if ( ferror(fm) )
{
	rc=NO_READ;
	goto Fin;
}
if ( mf->id!=ID_FONT )
{
	rc=NO_FILE;
	goto Fin;
}
mf->bits.ptr=(char far * )farmalloc(mf->len);
if ( mf->bits.ptr==0 ) { rc=NO_MEMORY; goto Fin; }
fseek(fm,off_bits,SEEK_SET);
//fread(mf->bits.ptr,mf->len,1,fm);
unzip_buf(fm,mf->len,mf->bits.ptr);

for ( i=0; i<256; i++ )
  mf->wt[i].o.ptr=(char far*)( mf->bits.ptr+mf->wt[i].o.off);

Fin:
if ( rc!=OK )
	if ( mf->bits.ptr!=0 ) farfree(mf->bits.ptr);
fclose(fm);
return rc;
}

	//
	//   䮭
	//
void	pascal magResetMFont
	( MagFont * mf )
{
if ( mf->bits.ptr!=0 )
	farfree(mf->bits.ptr);
memset(mf,0,sizeof(MagFont));
}

	//
	// 뢮 ᨬ
	//
void	pascal magCharMFont
	( char ch, word color, MagFont * mf )
{
word i, c, j, n;
word w, h, x, y;
char far * ptr;
c=(byte)ch;
if ( mf->wt[c].width==0 ) c=32; // ஡
ptr=mf->wt[c].o.ptr;
x=ptr_x; y=ptr_y;
if ( x+w>max_x ) w=max_x-x;
if ( y+h>max_y ) h=max_y-y;
w=mf->wt[c].width;
n=w/8+(w%8?1:0);
h=mf->height;

for ( i=0; i<n; i++ )
{
  for ( j=0; j<h; j++ )
  {
	c=(byte)*(ptr+j);
	magHorizPattern(x,y+j,8,color,c);
  }
  x+=8;
  ptr+=h;
}
}

#define DEL_X 5
#define DEL_Y 5

void	main
	( int argc, char * argv[] )
{
int x, y, i;

printf("ᬮ 䮭⮢ Maglib(FM). ᨬ .. 1995 v1\n");
if ( argc==1 ) { printf("  䠩\n"); return; }
i=MODE_640_480_256;
switch ( magSetGameMode(i) )
{
case OK: break; //{ printf("VESA ! 256\n"); getch(); break;}
case ERR_NO_VESA: { printf("NO_VESA !\n"); return; }
case ERR_NO_REG: { printf("NO 256\n"); return; }
}

if ( magReadFont("magsys.fnt")< 0 )
  { magSetDosMode(); printf(" magsys.fnt\n"); return; }

if ( magReadMFont(argv[1],&mf)!=OK )
  { magSetDosMode(); magResetFont();  printf(" - %s\n",argv[1]); return; }

x=10; y=10;

magXY(0,0);
magRect(max_x+1,max_y+1,1);

for ( i=32; i<256; i++ )
{
	if ( (x+mf.wt[i].width+DEL_X)>=max_x )
		{ x=10; y+=mf.height+DEL_Y; }
	if ( (y+mf.height+10)>=max_y )
	{
		gprintf(1,29,0xf0,
		" - %s;  - %d.    த ",
		mf.face, mf.height );
		read_key();
		magXY(0,0);
		magRect(max_x+1,max_y+1,1);
		x=10; y=10;
	}
	magXY(x,y);
	magCharMFont((char)i,0xe,&mf);
	x+=mf.wt[i].width+DEL_X;
}

gprintf(1,29,0xf0,"  - %s;  - %d.    த ",
 mf.face, mf.height );
read_key();

magSetDosMode();
magResetMFont(&mf);

}

